Index: NEMO/trunk/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/trunk/src/OCE/ZDF/zdfosm.F90	(revision 14903)
+++ NEMO/trunk/src/OCE/ZDF/zdfosm.F90	(revision 14921)
@@ -2168,132 +1698,1001 @@
       !!
       !!----------------------------------------------------------------------
-
-      REAL(wp), DIMENSION(jpi,jpj) :: dh, zdh     ! pycnocline thickness.
-       !
-      INTEGER :: jj, ji
-      INTEGER :: inhml
-      REAL(wp) :: zari, ztau, zdh_ref
-      REAL, PARAMETER :: a_ddh_2 = 3.5 ! also in pycnocline_depth
-
-    DO_2D( 0, 0, 0, 0 )
-
-      IF ( lshear(ji,jj) ) THEN
-         IF ( lconv(ji,jj) ) THEN
-           IF ( j_ddh(ji,jj) == 0 ) THEN
-! ddhdt for pycnocline determined in osm_calculate_dhdt
-             dh(ji,jj) = dh(ji,jj) + zddhdt(ji,jj) * rn_Dt
-           ELSE
-! Temporary (probably) Recalculate dh_ref to ensure dh doesn't go negative. Can't do this using zddhdt from calculate_dhdt
-             IF ( ( zwstrc(ji,jj) / zvstr(ji,jj) )**3 <= 0.5 ) THEN
-               zari = MIN( 1.5 * zdb_bl(ji,jj) / ( zhbl(ji,jj) * ( MAX(zdbdz_bl_ext(ji,jj),0._wp) + zdb_bl(ji,jj)**2 / MAX(4.5 * zvstr(ji,jj)**2 , 1.e-12 )) ), 0.2d0 )
-             ELSE
-               zari = MIN( 1.5 * zdb_bl(ji,jj) / ( zhbl(ji,jj) * ( MAX(zdbdz_bl_ext(ji,jj),0._wp) + zdb_bl(ji,jj)**2 / MAX(4.5 * zwstrc(ji,jj)**2 , 1.e-12 )) ), 0.2d0 )
-             ENDIF
-             ztau = MAX( zdb_bl(ji,jj) * ( zari * hbl(ji,jj) ) / ( a_ddh_2 * MAX(-zwb_ent(ji,jj), 1.e-12) ), 2.0 * rn_Dt )
-             dh(ji,jj) = dh(ji,jj) * EXP( -rn_Dt / ztau ) + zari * zhbl(ji,jj) * ( 1.0 - EXP( -rn_Dt / ztau ) )
-             IF ( dh(ji,jj) >= hbl(ji,jj) ) dh(ji,jj) = zari * zhbl(ji,jj)
-           ENDIF
-
-         ELSE ! lconv
-! Initially shear only for entraining OSBL. Stable code will be needed if extended to stable OSBL
-
-            ztau = hbl(ji,jj) / MAX(zvstr(ji,jj), epsln)
-            IF ( zdhdt(ji,jj) >= 0.0 ) THEN    ! probably shouldn't include wm here
-               ! boundary layer deepening
-               IF ( zdb_bl(ji,jj) > 0._wp ) THEN
-                  ! pycnocline thickness set by stratification - use same relationship as for neutral conditions.
-                  zari = MIN( 4.5 * ( zvstr(ji,jj)**2 ) &
-                       & /  MAX(zdb_bl(ji,jj) * zhbl(ji,jj), epsln ) + 0.01  , 0.2 )
-                  zdh_ref = MIN( zari, 0.2 ) * hbl(ji,jj)
+      INTEGER,                            INTENT(in   ) ::   Kmm            ! Ocean time-level index
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(inout) ::   pdh            ! Pycnocline thickness
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(inout) ::   phml           ! ML depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   pdhdt          ! BL depth tendency
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   phbl           ! BL depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   pwb_ent        ! Buoyancy entrainment flux
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   pdbdz_bl_ext   ! External buoyancy gradients
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   pwb_fk_b       ! MLE buoyancy flux averaged over OSBL
+      !!
+      INTEGER  ::   jj, ji
+      INTEGER  ::   inhml
+      REAL(wp) ::   zari, ztau, zdh_ref, zddhdt, zvel_max
+      REAL(wp) ::   ztmp   ! Auxiliary variable
+      !!
+      REAL, PARAMETER ::   pp_ddh = 2.5_wp, pp_ddh_2 = 3.5_wp   ! Also in pycnocline_depth
+      !!----------------------------------------------------------------------
+      !
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         !
+         IF ( l_shear(ji,jj) ) THEN
+            !
+            IF ( l_conv(ji,jj) ) THEN
+               !
+               IF ( av_db_bl(ji,jj) > 1e-15_wp ) THEN
+                  IF ( n_ddh(ji,jj) == 0 ) THEN
+                     zvel_max = ( svstr(ji,jj)**3 + 0.5_wp * swstrc(ji,jj)**3 )**p2third / hbl(ji,jj)
+                     ! ddhdt for pycnocline determined in osm_calculate_dhdt
+                     zddhdt = -1.0_wp * pp_ddh * ( 1.0_wp - 1.6_wp * pdh(ji,jj) / phbl(ji,jj) ) * pwb_ent(ji,jj) /   &
+                        &     ( zvel_max + MAX( av_db_bl(ji,jj), 1e-15 ) )
+                     zddhdt = EXP( -4.0_wp * ABS( ff_t(ji,jj) ) * phbl(ji,jj) / MAX( sustar(ji,jj), 1e-8 ) ) * zddhdt
+                     ! Maximum limit for how thick the shear layer can grow relative to the thickness of the boundary layer
+                     dh(ji,jj) = MIN( dh(ji,jj) + zddhdt * rn_Dt, 0.625_wp * hbl(ji,jj) )
+                  ELSE   ! Need to recalculate because hbl has been updated
+                     IF ( ( swstrc(ji,jj) / svstr(ji,jj) )**3 <= 0.5_wp ) THEN
+                        ztmp = svstr(ji,jj)
+                     ELSE
+                        ztmp = swstrc(ji,jj)
+                     END IF
+                     zari = MIN( 1.5_wp * av_db_bl(ji,jj) / ( phbl(ji,jj) * ( MAX( pdbdz_bl_ext(ji,jj), 0.0_wp ) +        &
+                        &                                                   av_db_bl(ji,jj)**2 / MAX( 4.5_wp * ztmp**2,   &
+                        &                                                                           1e-12_wp ) ) ), 0.2_wp )
+                     ztau = MAX( av_db_bl(ji,jj) * ( zari * hbl(ji,jj) ) /   &
+                        &        ( pp_ddh_2 * MAX( -1.0_wp * pwb_ent(ji,jj), 1e-12_wp ) ), 2.0_wp * rn_Dt )
+                     dh(ji,jj) = dh(ji,jj) * EXP( -1.0_wp * rn_Dt / ztau ) +   &
+                        &        zari * phbl(ji,jj) * ( 1.0_wp - EXP( -1.0_wp * rn_Dt / ztau ) )
+                     IF ( dh(ji,jj) >= hbl(ji,jj) ) dh(ji,jj) = zari * phbl(ji,jj)
+                  END IF
                ELSE
-                  zdh_ref = 0.2 * hbl(ji,jj)
+                  ztau = MAX( MAX( hbl(ji,jj) / ( svstr(ji,jj)**3 + 0.5_wp * swstrc(ji,jj)**3 )**pthird, epsln), 2.0_wp * rn_Dt )
+                  dh(ji,jj) = dh(ji,jj) * EXP( -1.0_wp * rn_Dt / ztau ) +   &
+                     &        0.2_wp * phbl(ji,jj) * ( 1.0_wp - EXP( -1.0_wp * rn_Dt / ztau ) )
+                  IF ( dh(ji,jj) > hbl(ji,jj) ) dh(ji,jj) = 0.2_wp * hbl(ji,jj)
+               END IF
+               !
+            ELSE   ! l_conv
+               ! Initially shear only for entraining OSBL. Stable code will be needed if extended to stable OSBL
+               ztau = hbl(ji,jj) / MAX(svstr(ji,jj), epsln)
+               IF ( pdhdt(ji,jj) >= 0.0_wp ) THEN   ! Probably shouldn't include wm here
+                  ! Boundary layer deepening
+                  IF ( av_db_bl(ji,jj) > 0.0_wp ) THEN
+                     ! Pycnocline thickness set by stratification - use same relationship as for neutral conditions
+                     zari    = MIN( 4.5_wp * ( svstr(ji,jj)**2 ) / MAX( av_db_bl(ji,jj) * phbl(ji,jj), epsln ) + 0.01_wp, 0.2_wp )
+                     zdh_ref = MIN( zari, 0.2_wp ) * hbl(ji,jj)
+                  ELSE
+                     zdh_ref = 0.2_wp * hbl(ji,jj)
+                  ENDIF
+               ELSE   ! IF(dhdt < 0)
+                  zdh_ref = 0.2_wp * hbl(ji,jj)
+               ENDIF   ! IF (dhdt >= 0)
+               dh(ji,jj) = dh(ji,jj) * EXP( -1.0_wp * rn_Dt / ztau ) + zdh_ref * ( 1.0_wp - EXP( -1.0_wp * rn_Dt / ztau ) )
+               IF ( pdhdt(ji,jj) < 0.0_wp .AND. dh(ji,jj) >= hbl(ji,jj) ) dh(ji,jj) = zdh_ref   ! Can be a problem with dh>hbl for
+               !                                                                                !    rapid collapse
+            ENDIF
+            !
+         ELSE   ! l_shear = .FALSE., calculate ddhdt here
+            !
+            IF ( l_conv(ji,jj) ) THEN
+               !
+               IF( ln_osm_mle ) THEN
+                  IF ( ( pwb_ent(ji,jj) + 2.0_wp * pwb_fk_b(ji,jj) ) < 0.0_wp ) THEN   ! OSBL is deepening. Note wb_fk_b is zero if
+                     !                                                                 !    ln_osm_mle=F
+                     IF ( av_db_bl(ji,jj) > 0.0_wp .AND. pdbdz_bl_ext(ji,jj) > 0.0_wp ) THEN
+                        IF ( ( swstrc(ji,jj) / MAX( svstr(ji,jj), epsln) )**3 <= 0.5_wp ) THEN   ! Near neutral stability
+                           ztmp = svstr(ji,jj)
+                        ELSE   ! Unstable
+                           ztmp = swstrc(ji,jj)
+                        END IF
+                        zari = MIN( 1.5_wp * av_db_bl(ji,jj) /                               &
+                           &        ( phbl(ji,jj) * ( MAX( pdbdz_bl_ext(ji,jj), 0.0_wp ) +   &
+                           &                          av_db_bl(ji,jj)**2 / MAX( 4.5_wp * ztmp**2 , 1e-12_wp ) ) ), 0.2_wp )
+                     ELSE
+                        zari = 0.2_wp
+                     END IF
+                  ELSE
+                     zari = 0.2_wp
+                  END IF
+                  ztau    = 0.2_wp * hbl(ji,jj) / MAX( epsln, ( svstr(ji,jj)**3 + 0.5_wp * swstrc(ji,jj)**3 )**pthird )
+                  zdh_ref = zari * hbl(ji,jj)
+               ELSE   ! ln_osm_mle
+                  IF ( av_db_bl(ji,jj) > 0.0_wp .AND. pdbdz_bl_ext(ji,jj) > 0.0_wp ) THEN
+                     IF ( ( swstrc(ji,jj) / MAX( svstr(ji,jj), epsln ) )**3 <= 0.5_wp ) THEN   ! Near neutral stability
+                        ztmp = svstr(ji,jj)
+                     ELSE   ! Unstable
+                        ztmp = swstrc(ji,jj)
+                     END IF
+                     zari    = MIN( 1.5_wp * av_db_bl(ji,jj) /                               &
+                        &           ( phbl(ji,jj) * ( MAX( pdbdz_bl_ext(ji,jj), 0.0_wp ) +   &
+                        &                             av_db_bl(ji,jj)**2 / MAX( 4.5_wp * ztmp**2 , 1e-12_wp ) ) ), 0.2_wp )
+                  ELSE
+                     zari    = 0.2_wp
+                  END IF
+                  ztau    = hbl(ji,jj) / MAX( epsln, ( svstr(ji,jj)**3 + 0.5_wp * swstrc(ji,jj)**3 )**pthird )
+                  zdh_ref = zari * hbl(ji,jj)
+               END IF   ! ln_osm_mle
+               dh(ji,jj) = dh(ji,jj) * EXP( -1.0_wp * rn_Dt / ztau ) + zdh_ref * ( 1.0_wp - EXP( -1.0_wp * rn_Dt / ztau ) )
+               !               IF ( pdhdt(ji,jj) < 0._wp .and. dh(ji,jj) >= hbl(ji,jj) ) dh(ji,jj) = zdh_ref
+               IF ( dh(ji,jj) >= hbl(ji,jj) ) dh(ji,jj) = zdh_ref
+               ! Alan: this hml is never defined or used
+            ELSE   ! IF (l_conv)
+               !
+               ztau = hbl(ji,jj) / MAX( svstr(ji,jj), epsln )
+               IF ( pdhdt(ji,jj) >= 0.0_wp ) THEN   ! Probably shouldn't include wm here
+                  ! Boundary layer deepening
+                  IF ( av_db_bl(ji,jj) > 0.0_wp ) THEN
+                     ! Pycnocline thickness set by stratification - use same relationship as for neutral conditions.
+                     zari    = MIN( 4.5_wp * ( svstr(ji,jj)**2 ) / MAX( av_db_bl(ji,jj) * phbl(ji,jj), epsln ) + 0.01_wp , 0.2_wp )
+                     zdh_ref = MIN( zari, 0.2_wp ) * hbl(ji,jj)
+                  ELSE
+                     zdh_ref = 0.2_wp * hbl(ji,jj)
+                  END IF
+               ELSE   ! IF(dhdt < 0)
+                  zdh_ref = 0.2_wp * hbl(ji,jj)
+               END IF   ! IF (dhdt >= 0)
+               dh(ji,jj) = dh(ji,jj) * EXP( -1.0_wp * rn_Dt / ztau ) + zdh_ref * ( 1.0_wp - EXP( -1.0_wp * rn_Dt / ztau ) )
+               IF ( pdhdt(ji,jj) < 0.0_wp .AND. dh(ji,jj) >= hbl(ji,jj) ) dh(ji,jj) = zdh_ref   ! Can be a problem with dh>hbl for
+               !                                                                                !    rapid collapse
+            END IF   ! IF (l_conv)
+            !
+         END IF   ! l_shear
+         !
+         hml(ji,jj)  = hbl(ji,jj) - dh(ji,jj)
+         inhml       = MAX( INT( dh(ji,jj) / MAX( e3t(ji,jj,nbld(ji,jj)-1,Kmm), 1e-3_wp ) ), 1 )
+         nmld(ji,jj) = MAX( nbld(ji,jj) - inhml, 3 )
+         phml(ji,jj) = gdepw(ji,jj,nmld(ji,jj),Kmm)
+         pdh(ji,jj)  = phbl(ji,jj) - phml(ji,jj)
+         !
+      END_2D
+      !
+   END SUBROUTINE zdf_osm_pycnocline_thickness
+
+   SUBROUTINE zdf_osm_pycnocline_buoyancy_profiles( Kmm, kp_ext, pdbdz, palpha, pdh,   &
+      &                                             phbl, pdbdz_bl_ext, phml, pdhdt )
+      !!---------------------------------------------------------------------
+      !!       ***  ROUTINE zdf_osm_pycnocline_buoyancy_profiles  ***
+      !!
+      !! ** Purpose : calculate pycnocline buoyancy profiles
+      !!
+      !! ** Method  : 
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER,                                 INTENT(in   ) ::   Kmm            ! Ocean time-level index
+      INTEGER,  DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   kp_ext         ! External-level offsets
+      REAL(wp), DIMENSION(A2D(nn_hls-1),jpk),  INTENT(  out) ::   pdbdz          ! Gradients in the pycnocline
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(  out) ::   palpha
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pdh            ! Pycnocline thickness
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   phbl           ! BL depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pdbdz_bl_ext   ! External buoyancy gradients
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   phml           ! ML depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pdhdt          ! Rates of change of hbl
+      !!
+      INTEGER  ::   jk, jj, ji
+      REAL(wp) ::   zbgrad
+      REAL(wp) ::   zgamma_b_nd, znd
+      REAL(wp) ::   zzeta_m
+      REAL(wp) ::   ztmp   ! Auxiliary variable
+      !!
+      REAL(wp), PARAMETER ::   pp_gamma_b = 2.25_wp
+      REAL(wp), PARAMETER ::   pp_large   = -1e10_wp
+      !!----------------------------------------------------------------------
+      !
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )      
+         pdbdz(ji,jj,:) = pp_large
+         palpha(ji,jj)  = pp_large
+      END_2D
+      !
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         !
+         IF ( nbld(ji,jj) + kp_ext(ji,jj) < mbkt(ji,jj) ) THEN
+            !
+            IF ( l_conv(ji,jj) ) THEN   ! Convective conditions
+               !
+               IF ( l_pyc(ji,jj) ) THEN
+                  !
+                  zzeta_m = 0.1_wp + 0.3_wp / ( 1.0_wp + EXP( -3.5_wp * LOG10( -1.0_wp * shol(ji,jj) ) ) )
+                  palpha(ji,jj) = 2.0_wp * ( 1.0_wp - ( 0.80_wp * zzeta_m + 0.5_wp * SQRT( 3.14159_wp / pp_gamma_b ) ) *   &
+                     &                                pdbdz_bl_ext(ji,jj) * pdh(ji,jj) / av_db_ml(ji,jj) ) /                &
+                     &            ( 0.723_wp + SQRT( 3.14159_wp / pp_gamma_b ) )
+                  palpha(ji,jj) = MAX( palpha(ji,jj), 0.0_wp )
+                  ztmp = 1.0_wp / MAX( pdh(ji,jj), epsln )
+                  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+                  ! Commented lines in this section are not needed in new code, once tested !
+                  ! can be removed                                                          !
+                  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+                  ! ztgrad = zalpha * av_dt_ml(ji,jj) * ztmp + zdtdz_bl_ext(ji,jj)
+                  ! zsgrad = zalpha * av_ds_ml(ji,jj) * ztmp + zdsdz_bl_ext(ji,jj)
+                  zbgrad = palpha(ji,jj) * av_db_ml(ji,jj) * ztmp + pdbdz_bl_ext(ji,jj)
+                  zgamma_b_nd = pdbdz_bl_ext(ji,jj) * pdh(ji,jj) / MAX( av_db_ml(ji,jj), epsln )
+                  DO jk = 2, nbld(ji,jj)
+                     znd = -1.0_wp * ( gdepw(ji,jj,jk,Kmm) - phbl(ji,jj) ) * ztmp
+                     IF ( znd <= zzeta_m ) THEN
+                        ! zdtdz(ji,jj,jk) = zdtdz_bl_ext(ji,jj) + zalpha * av_dt_ml(ji,jj) * ztmp * &
+                        ! &        EXP( -6.0 * ( znd -zzeta_m )**2 )
+                        ! zdsdz(ji,jj,jk) = zdsdz_bl_ext(ji,jj) + zalpha * av_ds_ml(ji,jj) * ztmp * &
+                        ! & EXP( -6.0 * ( znd -zzeta_m )**2 )
+                        pdbdz(ji,jj,jk) = pdbdz_bl_ext(ji,jj) + palpha(ji,jj) * av_db_ml(ji,jj) * ztmp * &
+                           & EXP( -6.0_wp * ( znd -zzeta_m )**2 )
+                     ELSE
+                        ! zdtdz(ji,jj,jk) =  ztgrad * EXP( -pp_gamma_b * ( znd - zzeta_m )**2 )
+                        ! zdsdz(ji,jj,jk) =  zsgrad * EXP( -pp_gamma_b * ( znd - zzeta_m )**2 )
+                        pdbdz(ji,jj,jk) =  zbgrad * EXP( -1.0_wp * pp_gamma_b * ( znd - zzeta_m )**2 )
+                     END IF
+                  END DO
+               END IF   ! If no pycnocline pycnocline gradients set to zero
+               !
+            ELSE   ! Stable conditions
+               ! If pycnocline profile only defined when depth steady of increasing.
+               IF ( pdhdt(ji,jj) > 0.0_wp ) THEN   ! Depth increasing, or steady.
+                  IF ( av_db_bl(ji,jj) > 0.0_wp ) THEN
+                     IF ( shol(ji,jj) >= 0.5_wp ) THEN   ! Very stable - 'thick' pycnocline
+                        ztmp = 1.0_wp / MAX( phbl(ji,jj), epsln )
+                        zbgrad = av_db_bl(ji,jj) * ztmp
+                        DO jk = 2, nbld(ji,jj)
+                           znd = gdepw(ji,jj,jk,Kmm) * ztmp
+                           pdbdz(ji,jj,jk) = zbgrad * EXP( -15.0_wp * ( znd - 0.9_wp )**2 )
+                        END DO
+                     ELSE   ! Slightly stable - 'thin' pycnoline - needed when stable layer begins to form.
+                        ztmp = 1.0_wp / MAX( pdh(ji,jj), epsln )
+                        zbgrad = av_db_bl(ji,jj) * ztmp
+                        DO jk = 2, nbld(ji,jj)
+                           znd = -1.0_wp * ( gdepw(ji,jj,jk,Kmm) - phml(ji,jj) ) * ztmp
+                           pdbdz(ji,jj,jk) = zbgrad * EXP( -1.75_wp * ( znd + 0.75_wp )**2 )
+                        END DO
+                     END IF   ! IF (shol >=0.5)
+                  END IF      ! IF (av_db_bl> 0.)
+               END IF         ! IF (pdhdt >= 0) pdhdt < 0 not considered since pycnocline profile is zero and profile arrays are
+               !              !    intialized to zero
+               !
+            END IF            ! IF (l_conv)
+            !
+         END IF   ! IF ( nbld(ji,jj) < mbkt(ji,jj) )
+         !
+      END_2D
+      !
+      IF ( ln_dia_pyc_scl ) THEN   ! Output of pycnocline gradient profiles
+         CALL zdf_osm_iomput( "zdbdz_pyc", wmask(A2D(0),:) * pdbdz(A2D(0),:) )
+      END IF
+      !
+   END SUBROUTINE zdf_osm_pycnocline_buoyancy_profiles
+
+   SUBROUTINE zdf_osm_diffusivity_viscosity( Kbb, Kmm, pdiffut, pviscos, phbl,   &
+      &                                      phml, pdh, pdhdt, pshear,           &
+      &                                      pwb_ent, pwb_min )
+      !!---------------------------------------------------------------------
+      !!           ***  ROUTINE zdf_osm_diffusivity_viscosity  ***
+      !!
+      !! ** Purpose : Determines the eddy diffusivity and eddy viscosity
+      !!              profiles in the mixed layer and the pycnocline.
+      !!
+      !! ** Method  :
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER,                                 INTENT(in   ) ::   Kbb, Kmm       ! Ocean time-level indices
+      REAL(wp), DIMENSION(A2D(nn_hls-1),jpk),  INTENT(inout) ::   pdiffut        ! t-diffusivity
+      REAL(wp), DIMENSION(A2D(nn_hls-1),jpk),  INTENT(inout) ::   pviscos        ! Viscosity
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   phbl           ! BL depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   phml           ! ML depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pdh            ! Pycnocline depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pdhdt          ! BL depth tendency
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pshear         ! Shear production
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pwb_ent        ! Buoyancy entrainment flux
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pwb_min
+      !!
+      INTEGER ::   ji, jj, jk   ! Loop indices
+      !! Scales used to calculate eddy diffusivity and viscosity profiles
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zdifml_sc,    zvisml_sc
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zdifpyc_n_sc, zdifpyc_s_sc
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zvispyc_n_sc, zvispyc_s_sc
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zbeta_d_sc,   zbeta_v_sc
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zb_coup,      zc_coup_vis,  zc_coup_dif
+      !!
+      REAL(wp) ::   zvel_sc_pyc, zvel_sc_ml, zstab_fac, zz_b
+      REAL(wp) ::   za_cubic, zb_d_cubic, zc_d_cubic, zd_d_cubic,   &   ! Coefficients in cubic polynomial specifying diffusivity
+         &                    zb_v_cubic, zc_v_cubic, zd_v_cubic        ! and viscosity in pycnocline
+      REAL(wp) ::   zznd_ml, zznd_pyc, ztmp
+      REAL(wp) ::   zmsku, zmskv
+      !!
+      REAL(wp), PARAMETER ::   pp_dif_ml     = 0.8_wp,  pp_vis_ml  = 0.375_wp
+      REAL(wp), PARAMETER ::   pp_dif_pyc    = 0.15_wp, pp_vis_pyc = 0.142_wp
+      REAL(wp), PARAMETER ::   pp_vispyc_shr = 0.15_wp
+      !!----------------------------------------------------------------------
+      !
+      zb_coup(:,:) = 0.0_wp
+      !
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         IF ( l_conv(ji,jj) ) THEN
+            !
+            zvel_sc_pyc = ( 0.15_wp * svstr(ji,jj)**3 + swstrc(ji,jj)**3 + 4.25_wp * pshear(ji,jj) * phbl(ji,jj) )**pthird
+            zvel_sc_ml  = ( svstr(ji,jj)**3 + 0.5_wp * swstrc(ji,jj)**3 )**pthird
+            zstab_fac   = ( phml(ji,jj) / zvel_sc_ml *   &
+               &            ( 1.4_wp - 0.4_wp / ( 1.0_wp + EXP(-3.5_wp * LOG10( -1.0_wp * shol(ji,jj) ) ) )**1.25_wp ) )**2
+            !
+            zdifml_sc(ji,jj) = pp_dif_ml * phml(ji,jj) * zvel_sc_ml
+            zvisml_sc(ji,jj) = pp_vis_ml * zdifml_sc(ji,jj)
+            !
+            IF ( l_pyc(ji,jj) ) THEN
+               zdifpyc_n_sc(ji,jj) = pp_dif_pyc * zvel_sc_ml * pdh(ji,jj)
+               zvispyc_n_sc(ji,jj) = 0.09_wp * zvel_sc_pyc * ( 1.0_wp - phbl(ji,jj) / pdh(ji,jj) )**2 *   &
+                  &                  ( 0.005_wp  * ( av_u_ml(ji,jj) - av_u_bl(ji,jj) )**2 +     &
+                  &                    0.0075_wp * ( av_v_ml(ji,jj) - av_v_bl(ji,jj) )**2 ) /   &
+                  &                  pdh(ji,jj)
+               zvispyc_n_sc(ji,jj) = pp_vis_pyc * zvel_sc_ml * pdh(ji,jj) + zvispyc_n_sc(ji,jj) * zstab_fac
+               !
+               IF ( l_shear(ji,jj) .AND. n_ddh(ji,jj) /= 2 ) THEN
+                  ztmp = pp_vispyc_shr * ( pshear(ji,jj) * phbl(ji,jj) )**pthird * phbl(ji,jj)
+                  zdifpyc_n_sc(ji,jj) = zdifpyc_n_sc(ji,jj) + ztmp
+                  zvispyc_n_sc(ji,jj) = zvispyc_n_sc(ji,jj) + ztmp
                ENDIF
-            ELSE     ! IF(dhdt < 0)
-               zdh_ref = 0.2 * hbl(ji,jj)
-            ENDIF    ! IF (dhdt >= 0)
-            dh(ji,jj) = dh(ji,jj) * EXP( -rn_Dt / ztau )+ zdh_ref * ( 1.0 - EXP( -rn_Dt / ztau ) )
-            IF ( zdhdt(ji,jj) < 0._wp .and. dh(ji,jj) >= hbl(ji,jj) ) dh(ji,jj) = zdh_ref       ! can be a problem with dh>hbl for rapid collapse
-            ! Alan: this hml is never defined or used -- do we need it?
+               !
+               zdifpyc_s_sc(ji,jj) = pwb_ent(ji,jj) + 0.0025_wp * zvel_sc_pyc * ( phbl(ji,jj) / pdh(ji,jj) - 1.0_wp ) *   &
+                  &                                   ( av_b_ml(ji,jj) - av_b_bl(ji,jj) )
+               zvispyc_s_sc(ji,jj) = 0.09_wp * ( pwb_min(ji,jj) + 0.0025_wp * zvel_sc_pyc *                 &
+                  &                                               ( phbl(ji,jj) / pdh(ji,jj) - 1.0_wp ) *   &
+                  &                                               ( av_b_ml(ji,jj) - av_b_bl(ji,jj) ) )
+               zdifpyc_s_sc(ji,jj) = 0.09_wp * zdifpyc_s_sc(ji,jj) * zstab_fac
+               zvispyc_s_sc(ji,jj) = zvispyc_s_sc(ji,jj) * zstab_fac
+               !
+               zdifpyc_s_sc(ji,jj) = MAX( zdifpyc_s_sc(ji,jj), -0.5_wp * zdifpyc_n_sc(ji,jj) )
+               zvispyc_s_sc(ji,jj) = MAX( zvispyc_s_sc(ji,jj), -0.5_wp * zvispyc_n_sc(ji,jj) )
+               
+               zbeta_d_sc(ji,jj) = 1.0_wp - ( ( zdifpyc_n_sc(ji,jj) + 1.4_wp * zdifpyc_s_sc(ji,jj) ) /   &
+                  &                           ( zdifml_sc(ji,jj) + epsln ) )**p2third
+               zbeta_v_sc(ji,jj) = 1.0_wp - 2.0_wp * ( zvispyc_n_sc(ji,jj) + zvispyc_s_sc(ji,jj) ) / ( zvisml_sc(ji,jj) + epsln )
+            ELSE
+               zdifpyc_n_sc(ji,jj) = pp_dif_pyc * zvel_sc_ml * pdh(ji,jj)   ! ag 19/03
+               zdifpyc_s_sc(ji,jj) = 0.0_wp   ! ag 19/03
+               zvispyc_n_sc(ji,jj) = pp_vis_pyc * zvel_sc_ml * pdh(ji,jj)   ! ag 19/03
+               zvispyc_s_sc(ji,jj) = 0.0_wp   ! ag 19/03
+               IF(l_coup(ji,jj) ) THEN   ! ag 19/03
+                  ! code from SUBROUTINE tke_tke zdftke.F90; uses bottom drag velocity rCdU_bot(ji,jj) = -Cd|ub|
+                  !     already calculated at T-points in SUBROUTINE zdf_drg from zdfdrg.F90
+                  !  Gives friction velocity sqrt bottom drag/rho_0 i.e. u* = SQRT(rCdU_bot*ub)
+                  ! wet-cell averaging ..
+                  zmsku = 0.5_wp * ( 2.0_wp - umask(ji-1,jj,mbkt(ji,jj)) * umask(ji,jj,mbkt(ji,jj)) )
+                  zmskv = 0.5_wp * ( 2.0_wp - vmask(ji,jj-1,mbkt(ji,jj)) * vmask(ji,jj,mbkt(ji,jj)) )
+                  zb_coup(ji,jj) = 0.4_wp * SQRT(-1.0_wp * rCdU_bot(ji,jj) *   &
+                     &             SQRT(  ( zmsku*( uu(ji,jj,mbkt(ji,jj),Kbb)+uu(ji-1,jj,mbkt(ji,jj),Kbb) ) )**2   &
+                     &                  + ( zmskv*( vv(ji,jj,mbkt(ji,jj),Kbb)+vv(ji,jj-1,mbkt(ji,jj),Kbb) ) )**2  ) )
+                  
+                  zz_b = -1.0_wp * gdepw(ji,jj,mbkt(ji,jj)+1,Kmm)   ! ag 19/03
+                  zc_coup_vis(ji,jj) = -0.5_wp * ( 0.5_wp * zvisml_sc(ji,jj) / phml(ji,jj) - zb_coup(ji,jj) ) /   &
+                     &                 ( phml(ji,jj) + zz_b )   ! ag 19/03
+                  zz_b = -1.0_wp * phml(ji,jj) + gdepw(ji,jj,mbkt(ji,jj)+1,Kmm)   ! ag 19/03
+                  zbeta_v_sc(ji,jj) = 1.0_wp - 2.0_wp * ( zb_coup(ji,jj) * zz_b + zc_coup_vis(ji,jj) * zz_b**2 ) /   &
+                     &                                  zvisml_sc(ji,jj)   ! ag 19/03
+                  zbeta_d_sc(ji,jj) = 1.0_wp - ( ( zb_coup(ji,jj) * zz_b + zc_coup_vis(ji,jj) * zz_b**2 ) /   &
+                     &                           zdifml_sc(ji,jj) )**p2third
+                  zc_coup_dif(ji,jj) = 0.5_wp * ( -zdifml_sc(ji,jj) / phml(ji,jj) * ( 1.0_wp - zbeta_d_sc(ji,jj) )**1.5_wp +   &
+                     &                 1.5_wp * ( zdifml_sc(ji,jj) / phml(ji,jj) ) * zbeta_d_sc(ji,jj) *   &
+                     &                          SQRT( 1.0_wp - zbeta_d_sc(ji,jj) ) - zb_coup(ji,jj) ) / zz_b   ! ag 19/03
+               ELSE   ! ag 19/03
+                  zbeta_d_sc(ji,jj) = 1.0_wp - ( ( zdifpyc_n_sc(ji,jj) + 1.4_wp * zdifpyc_s_sc(ji,jj) ) /   &
+                     &                           ( zdifml_sc(ji,jj) + epsln ) )**p2third   ! ag 19/03
+                  zbeta_v_sc(ji,jj) = 1.0_wp - 2.0_wp * ( zvispyc_n_sc(ji,jj) + zvispyc_s_sc(ji,jj) ) /   &
+                     &                         ( zvisml_sc(ji,jj) + epsln )   ! ag 19/03
+               ENDIF   ! ag 19/03
+            ENDIF      ! ag 19/03
+         ELSE
+            zdifml_sc(ji,jj) = svstr(ji,jj) * phbl(ji,jj) * MAX( EXP ( -1.0_wp * ( shol(ji,jj) / 0.6_wp )**2 ), 0.2_wp)
+            zvisml_sc(ji,jj) = zdifml_sc(ji,jj)
+         END IF
+      END_2D
+      !
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         IF ( l_conv(ji,jj) ) THEN
+            DO jk = 2, nmld(ji,jj)   ! Mixed layer diffusivity
+               zznd_ml = gdepw(ji,jj,jk,Kmm) / phml(ji,jj)
+               pdiffut(ji,jj,jk) = zdifml_sc(ji,jj) * zznd_ml * ( 1.0_wp - zbeta_d_sc(ji,jj) * zznd_ml )**1.5
+               pviscos(ji,jj,jk) = zvisml_sc(ji,jj) * zznd_ml * ( 1.0_wp - zbeta_v_sc(ji,jj) * zznd_ml ) *   &
+                  &                ( 1.0_wp - 0.5_wp * zznd_ml**2 )
+            END DO
+            !
+            ! Coupling to bottom
+            !
+            IF ( l_coup(ji,jj) ) THEN                                                         ! ag 19/03
+               DO jk = mbkt(ji,jj), nmld(ji,jj), -1                                           ! ag 19/03
+                  zz_b = -1.0_wp * ( gdepw(ji,jj,jk,Kmm) - gdepw(ji,jj,mbkt(ji,jj)+1,Kmm) )   ! ag 19/03
+                  pviscos(ji,jj,jk) = zb_coup(ji,jj) * zz_b + zc_coup_vis(ji,jj) * zz_b**2    ! ag 19/03
+                  pdiffut(ji,jj,jk) = zb_coup(ji,jj) * zz_b + zc_coup_dif(ji,jj) * zz_b**2    ! ag 19/03
+               END DO                                                                         ! ag 19/03
+            ENDIF                                                                             ! ag 19/03
+            ! Pycnocline
+            IF ( l_pyc(ji,jj) ) THEN 
+               ! Diffusivity and viscosity profiles in the pycnocline given by
+               ! cubic polynomial. Note, if l_pyc TRUE can't be coupled to seabed.
+               za_cubic = 0.5_wp
+               zb_d_cubic = -1.75_wp * zdifpyc_s_sc(ji,jj) / zdifpyc_n_sc(ji,jj)
+               zd_d_cubic = ( pdh(ji,jj) * zdifml_sc(ji,jj) / phml(ji,jj) * SQRT( 1.0_wp - zbeta_d_sc(ji,jj) ) *   &
+                  &           ( 2.5_wp * zbeta_d_sc(ji,jj) - 1.0_wp ) - 0.85_wp * zdifpyc_s_sc(ji,jj) ) /            &
+                  &           MAX( zdifpyc_n_sc(ji,jj), 1.0e-8_wp )
+               zd_d_cubic = zd_d_cubic - zb_d_cubic - 2.0_wp * ( 1.0_wp - za_cubic  - zb_d_cubic )
+               zc_d_cubic = 1.0_wp - za_cubic - zb_d_cubic - zd_d_cubic
+               zb_v_cubic = -1.75_wp * zvispyc_s_sc(ji,jj) / zvispyc_n_sc(ji,jj)
+               zd_v_cubic = ( 0.5_wp * zvisml_sc(ji,jj) * pdh(ji,jj) / phml(ji,jj) - 0.85_wp * zvispyc_s_sc(ji,jj) ) /   &
+                  &           MAX( zvispyc_n_sc(ji,jj), 1.0e-8_wp )
+               zd_v_cubic = zd_v_cubic - zb_v_cubic - 2.0_wp * ( 1.0_wp - za_cubic - zb_v_cubic )
+               zc_v_cubic = 1.0_wp - za_cubic - zb_v_cubic - zd_v_cubic
+               DO jk = nmld(ji,jj) , nbld(ji,jj)
+                  zznd_pyc = -1.0_wp * ( gdepw(ji,jj,jk,Kmm) - phbl(ji,jj) ) / MAX(pdh(ji,jj), 1.0e-6_wp )
+                  ztmp = ( 1.75_wp * zznd_pyc - 0.15_wp * zznd_pyc**2 - 0.2_wp * zznd_pyc**3 )
+                  !
+                  pdiffut(ji,jj,jk) = zdifpyc_n_sc(ji,jj) *   &
+                     &                ( za_cubic + zb_d_cubic * zznd_pyc + zc_d_cubic * zznd_pyc**2 + zd_d_cubic * zznd_pyc**3 )
+                  !
+                  pdiffut(ji,jj,jk) = pdiffut(ji,jj,jk) + zdifpyc_s_sc(ji,jj) * ztmp
+                  pviscos(ji,jj,jk) = zvispyc_n_sc(ji,jj) *   &
+                     &                ( za_cubic + zb_v_cubic * zznd_pyc + zc_v_cubic * zznd_pyc**2 + zd_v_cubic * zznd_pyc**3 )
+                  pviscos(ji,jj,jk) = pviscos(ji,jj,jk) + zvispyc_s_sc(ji,jj) * ztmp
+               END DO
+   !                  IF ( pdhdt(ji,jj) > 0._wp ) THEN
+   !                     zdiffut(ji,jj,nbld(ji,jj)+1) = MAX( 0.5 * pdhdt(ji,jj) * e3w(ji,jj,nbld(ji,jj)+1,Kmm), 1.0e-6 )
+   !                     zviscos(ji,jj,nbld(ji,jj)+1) = MAX( 0.5 * pdhdt(ji,jj) * e3w(ji,jj,nbld(ji,jj)+1,Kmm), 1.0e-6 )
+   !                  ELSE
+   !                     zdiffut(ji,jj,nbld(ji,jj)) = 0._wp
+   !                     zviscos(ji,jj,nbld(ji,jj)) = 0._wp
+   !                  ENDIF
+            ENDIF
+         ELSE
+            ! Stable conditions
+            DO jk = 2, nbld(ji,jj)
+               zznd_ml = gdepw(ji,jj,jk,Kmm) / phbl(ji,jj)
+               pdiffut(ji,jj,jk) = 0.75_wp * zdifml_sc(ji,jj) * zznd_ml * ( 1.0_wp - zznd_ml )**1.5_wp
+               pviscos(ji,jj,jk) = 0.375_wp * zvisml_sc(ji,jj) * zznd_ml * ( 1.0_wp - zznd_ml ) * ( 1.0_wp - zznd_ml**2 )
+            END DO
+            !
+            IF ( pdhdt(ji,jj) > 0.0_wp ) THEN
+               pdiffut(ji,jj,nbld(ji,jj)) = MAX( pdhdt(ji,jj), 1.0e-6_wp) * e3w(ji, jj, nbld(ji,jj), Kmm)
+               pviscos(ji,jj,nbld(ji,jj)) = pdiffut(ji,jj,nbld(ji,jj))
+            ENDIF
+         ENDIF   ! End if ( l_conv )
+         !
+      END_2D
+      CALL zdf_osm_iomput( "pb_coup", tmask(A2D(0),1) * zb_coup(A2D(0)) )   ! BBL-coupling velocity scale
+      !
+   END SUBROUTINE zdf_osm_diffusivity_viscosity
+
+   SUBROUTINE zdf_osm_fgr_terms( Kmm, kp_ext, phbl, phml, pdh,                              &
+      &                          pdhdt, pshear, pdtdz_bl_ext, pdsdz_bl_ext, pdbdz_bl_ext,   &
+      &                          pdiffut, pviscos )
+      !!---------------------------------------------------------------------
+      !!                 ***  ROUTINE zdf_osm_fgr_terms ***
+      !!
+      !! ** Purpose : Compute non-gradient terms in flux-gradient relationship
+      !!
+      !! ** Method  :
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER,                                 INTENT(in   ) ::   Kmm            ! Time-level index
+      INTEGER,  DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   kp_ext         ! Offset for external level
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   phbl           ! BL depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   phml           ! ML depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pdh            ! Pycnocline depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pdhdt          ! BL depth tendency
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pshear         ! Shear production
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pdtdz_bl_ext   ! External temperature gradients
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pdsdz_bl_ext   ! External salinity gradients
+      REAL(wp), DIMENSION(A2D(nn_hls-1)),      INTENT(in   ) ::   pdbdz_bl_ext   ! External buoyancy gradients
+      REAL(wp), DIMENSION(A2D(nn_hls-1),jpk),  INTENT(in   ) ::   pdiffut        ! t-diffusivity
+      REAL(wp), DIMENSION(A2D(nn_hls-1),jpk),  INTENT(in   ) ::   pviscos        ! Viscosity
+      !!
+      REAL(wp), DIMENSION(A2D(nn_hls-1))     ::   zalpha_pyc   !
+      REAL(wp), DIMENSION(A2D(nn_hls-1),jpk) ::   zdbdz_pyc    ! Parametrised gradient of buoyancy in the pycnocline
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   z3ddz_pyc_1, z3ddz_pyc_2   ! Pycnocline gradient/shear profiles
+      !!
+      INTEGER                            ::   ji, jj, jk, jkm_bld, jkf_mld, jkm_mld   ! Loop indices
+      INTEGER                            ::   istat                                   ! Memory allocation status
+      REAL(wp)                           ::   zznd_d, zznd_ml, zznd_pyc, znd          ! Temporary non-dimensional depths
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zsc_wth_1,zsc_ws_1                      ! Temporary scales
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zsc_uw_1, zsc_uw_2                      ! Temporary scales
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zsc_vw_1, zsc_vw_2                      ! Temporary scales
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   ztau_sc_u                               ! Dissipation timescale at base of WML
+      REAL(wp)                           ::   zbuoy_pyc_sc, zdelta_pyc                !
+      REAL(wp)                           ::   zl_c,zl_l,zl_eps                        ! Used to calculate turbulence length scale
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   za_cubic, zb_cubic                      ! Coefficients in cubic polynomial specifying
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zc_cubic, zd_cubic                      !    diffusivity in pycnocline
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zwt_pyc_sc_1, zws_pyc_sc_1              !
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zzeta_pyc                               !
+      REAL(wp)                           ::   zomega, zvw_max                         !
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zuw_bse,zvw_bse                         ! Momentum, heat, and salinity fluxes
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zwth_ent,zws_ent                        !    at the top of the pycnocline
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   zsc_wth_pyc, zsc_ws_pyc                 ! Scales for pycnocline transport term
+      REAL(wp)                           ::   ztmp                                    !
+      REAL(wp)                           ::   ztgrad, zsgrad, zbgrad                  ! Variables used to calculate pycnocline
+      !!                                                                              !    gradients
+      REAL(wp)                           ::   zugrad, zvgrad                          ! Variables for calculating pycnocline shear
+      REAL(wp)                           ::   zdtdz_pyc                               ! Parametrized gradient of temperature in
+      !!                                                                              !    pycnocline
+      REAL(wp)                           ::   zdsdz_pyc                               ! Parametrised gradient of salinity in
+      !!                                                                              !    pycnocline
+      REAL(wp)                           ::   zdudz_pyc                               ! u-shear across the pycnocline
+      REAL(wp)                           ::   zdvdz_pyc                               ! v-shear across the pycnocline
+      !!----------------------------------------------------------------------
+      !
+      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+      !  Pycnocline gradients for scalars and velocity
+      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+      CALL zdf_osm_pycnocline_buoyancy_profiles( Kmm, kp_ext, zdbdz_pyc, zalpha_pyc, pdh,    &
+         &                                       phbl, pdbdz_bl_ext, phml, pdhdt )
+      !
+      ! Auxiliary indices
+      ! -----------------
+      jkm_bld = 0
+      jkf_mld = jpk
+      jkm_mld = 0
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         IF ( nbld(ji,jj) > jkm_bld ) jkm_bld = nbld(ji,jj)
+         IF ( nmld(ji,jj) < jkf_mld ) jkf_mld = nmld(ji,jj)
+         IF ( nmld(ji,jj) > jkm_mld ) jkm_mld = nmld(ji,jj)
+      END_2D
+      !
+      ! Stokes term in scalar flux, flux-gradient relationship
+      ! ------------------------------------------------------
+      WHERE ( l_conv(A2D(nn_hls-1)) )
+         zsc_wth_1(:,:) = swstrl(A2D(nn_hls-1))**3 * swth0(A2D(nn_hls-1)) /   &
+            &             ( svstr(A2D(nn_hls-1))**3 + 0.5_wp * swstrc(A2D(nn_hls-1))**3 + epsln )
+         zsc_ws_1(:,:)  = swstrl(A2D(nn_hls-1))**3 * sws0(A2D(nn_hls-1))  /   &
+            &             ( svstr(A2D(nn_hls-1))**3 + 0.5_wp * swstrc(A2D(nn_hls-1))**3 + epsln )
+      ELSEWHERE
+         zsc_wth_1(:,:) = 2.0_wp * swthav(A2D(nn_hls-1))
+         zsc_ws_1(:,:)  = 2.0_wp * swsav(A2D(nn_hls-1))
+      ENDWHERE
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, MAX( jkm_mld, jkm_bld ) )
+         IF ( l_conv(ji,jj) ) THEN
+            IF ( jk <= nmld(ji,jj) ) THEN
+               zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 1.35_wp * EXP( -1.0_wp * zznd_d ) *   &
+                  &                                ( 1.0_wp - EXP( -2.0_wp * zznd_d ) ) * zsc_wth_1(ji,jj)
+               ghams(ji,jj,jk) = ghams(ji,jj,jk) + 1.35_wp * EXP( -1.0_wp * zznd_d ) *   &
+                  &                                ( 1.0_wp - EXP( -2.0_wp * zznd_d ) ) * zsc_ws_1(ji,jj)
+            END IF
+         ELSE   ! Stable conditions
+            IF ( jk <= nbld(ji,jj) ) THEN
+               zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 2.15_wp * EXP( -0.85_wp * zznd_d ) *   &
+                  &                                ( 1.0_wp - EXP( -4.0_wp * zznd_d ) ) * zsc_wth_1(ji,jj)
+               ghams(ji,jj,jk) = ghams(ji,jj,jk) + 2.15_wp * EXP( -0.85_wp * zznd_d ) *   &
+                  &                                ( 1.0_wp - EXP( -4.0_wp * zznd_d ) ) * zsc_ws_1(ji,jj)
+            END IF
+         END IF   ! Check on l_conv
+      END_3D
+      !
+      IF ( ln_dia_osm ) THEN
+         CALL zdf_osm_iomput( "ghamu_00", wmask(A2D(0),:) * ghamu(A2D(0),:) )
+         CALL zdf_osm_iomput( "ghamv_00", wmask(A2D(0),:) * ghamv(A2D(0),:) )
+      END IF
+      !
+      ! Stokes term in flux-gradient relationship (note in zsc_uw_n don't use
+      ! svstr since term needs to go to zero as swstrl goes to zero)
+      ! ---------------------------------------------------------------------
+      WHERE ( l_conv(A2D(nn_hls-1)) )
+         zsc_uw_1(:,:) = ( swstrl(A2D(nn_hls-1))**3 +                                                &
+            &              0.5_wp * swstrc(A2D(nn_hls-1))**3 )**pthird * sustke(A2D(nn_hls-1)) /   &
+            &              MAX( ( 1.0_wp - 1.0_wp * 6.5_wp * sla(A2D(nn_hls-1))**( 8.0_wp / 3.0_wp ) ), 0.2_wp )
+         zsc_uw_2(:,:) = ( swstrl(A2D(nn_hls-1))**3 +                                                &
+            &              0.5_wp * swstrc(A2D(nn_hls-1))**3 )**pthird * sustke(A2D(nn_hls-1)) /   &
+            &              MIN( sla(A2D(nn_hls-1))**( 8.0_wp / 3.0_wp ) + epsln, 0.12_wp )
+         zsc_vw_1(:,:) = ff_t(A2D(nn_hls-1)) * phml(A2D(nn_hls-1)) * sustke(A2D(nn_hls-1))**3 *   &
+            &            MIN( sla(A2D(nn_hls-1))**( 8.0_wp / 3.0_wp ), 0.12_wp ) /                    &
+            &            ( ( svstr(A2D(nn_hls-1))**3 + 0.5_wp * swstrc(A2D(nn_hls-1))**3 )**( 2.0_wp / 3.0_wp ) + epsln )
+      ELSEWHERE
+         zsc_uw_1(:,:) = sustar(A2D(nn_hls-1))**2
+         zsc_vw_1(:,:) = ff_t(A2D(nn_hls-1)) * phbl(A2D(nn_hls-1)) * sustke(A2D(nn_hls-1))**3 *   &
+            &            MIN( sla(A2D(nn_hls-1))**( 8.0_wp / 3.0_wp ), 0.12_wp ) / ( svstr(A2D(nn_hls-1))**2 + epsln )
+      ENDWHERE
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, MAX( jkm_mld, jkm_bld ) )
+         IF ( l_conv(ji,jj) ) THEN
+            IF ( jk <= nmld(ji,jj) ) THEN
+               zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + ( -0.05_wp   * EXP( -0.4_wp * zznd_d ) * zsc_uw_1(ji,jj) +     &
+                  &                                  0.00125_wp * EXP( -1.0_wp * zznd_d ) * zsc_uw_2(ji,jj) ) *   &
+                  &                                ( 1.0_wp - EXP( -2.0_wp * zznd_d ) )
+               ghamv(ji,jj,jk) = ghamv(ji,jj,jk) - 0.65_wp *  0.15_wp * EXP( -1.0_wp * zznd_d ) *                 &
+                  &                                ( 1.0_wp - EXP( -2.0_wp * zznd_d ) ) * zsc_vw_1(ji,jj)
+            END IF
+         ELSE   ! Stable conditions
+            IF ( jk <= nbld(ji,jj) ) THEN   ! Corrected to nbld
+               zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               ghamu(ji,jj,jk) = ghamu(ji,jj,jk) - 0.75_wp * 1.3_wp * EXP( -0.5_wp * zznd_d ) *             &
+                  &                                ( 1.0_wp - EXP( -4.0_wp * zznd_d ) ) * zsc_uw_1(ji,jj)
+            END IF
+         END IF
+      END_3D
+      !
+      ! Buoyancy term in flux-gradient relationship [note : includes ROI ratio
+      ! (X0.3) and pressure (X0.5)]
+      ! ----------------------------------------------------------------------
+      WHERE ( l_conv(A2D(nn_hls-1)) )
+         zsc_wth_1(:,:) = swbav(A2D(nn_hls-1)) * swth0(A2D(nn_hls-1)) * ( 1.0_wp + EXP( 0.2_wp * shol(A2D(nn_hls-1)) ) ) *   &
+            &             phml(A2D(nn_hls-1)) / ( svstr(A2D(nn_hls-1))**3 + 0.5_wp * swstrc(A2D(nn_hls-1))**3 + epsln )
+         zsc_ws_1(:,:)  = swbav(A2D(nn_hls-1)) * sws0(A2D(nn_hls-1))  * ( 1.0_wp + EXP( 0.2_wp * shol(A2D(nn_hls-1)) ) ) *   &
+            &             phml(A2D(nn_hls-1)) / ( svstr(A2D(nn_hls-1))**3 + 0.5_wp * swstrc(A2D(nn_hls-1))**3 + epsln )
+      ELSEWHERE
+         zsc_wth_1(:,:) = 0.0_wp
+         zsc_ws_1(:,:)  = 0.0_wp
+      ENDWHERE
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, MAX( jkm_mld, jkm_bld ) )
+         IF ( l_conv(ji,jj) ) THEN
+            IF ( jk <= nmld(ji,jj) ) THEN
+               zznd_ml = gdepw(ji,jj,jk,Kmm) / phml(ji,jj)
+               ! Calculate turbulent time scale
+               zl_c   = 0.9_wp * ( 1.0_wp - EXP( -5.0_wp * ( zznd_ml + zznd_ml**3 / 3.0_wp ) ) ) *                         &
+                  &     ( 1.0_wp - EXP( -15.0_wp * ( 1.2_wp - zznd_ml ) ) )
+               zl_l   = 2.0_wp * ( 1.0_wp - EXP( -2.0_wp * ( zznd_ml + zznd_ml**3 / 3.0_wp ) ) ) *                         &
+                  &     ( 1.0_wp - EXP( -8.0_wp  * ( 1.15_wp - zznd_ml ) ) ) * ( 1.0_wp + dstokes(ji,jj) / phml (ji,jj) )
+               zl_eps = zl_l + ( zl_c - zl_l ) / ( 1.0_wp + EXP( -3.0_wp * LOG10( -1.0_wp * shol(ji,jj) ) ) )**( 3.0_wp / 2.0_wp )
+               ! Non-gradient buoyancy terms
+               ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 0.3_wp * 0.4_wp * zsc_wth_1(ji,jj) * zl_eps / ( 0.15_wp + zznd_ml )
+               ghams(ji,jj,jk) = ghams(ji,jj,jk) + 0.3_wp * 0.4_wp *  zsc_ws_1(ji,jj) * zl_eps / ( 0.15_wp + zznd_ml )
+            END IF
+         ELSE   ! Stable conditions
+            IF ( jk <= nbld(ji,jj) ) THEN
+               ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + zsc_wth_1(ji,jj)
+               ghams(ji,jj,jk) = ghams(ji,jj,jk) +  zsc_ws_1(ji,jj)
+            END IF
+         END IF
+      END_3D
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         IF ( l_conv(ji,jj) .AND. l_pyc(ji,jj) ) THEN
+            ztau_sc_u(ji,jj)    = phml(ji,jj) / ( svstr(ji,jj)**3 + swstrc(ji,jj)**3 )**pthird *                             &
+               &                ( 1.4_wp - 0.4_wp / ( 1.0_wp + EXP( -3.5_wp * LOG10( -1.0_wp * shol(ji,jj) ) ) )**1.5_wp )
+            zwth_ent(ji,jj)     = -0.003_wp * ( 0.15_wp * svstr(ji,jj)**3 + swstrc(ji,jj)**3 )**pthird *   &
+               &                ( 1.0_wp - pdh(ji,jj) / phbl(ji,jj) ) * av_dt_ml(ji,jj)
+            zws_ent(ji,jj)      = -0.003_wp * ( 0.15_wp * svstr(ji,jj)**3 + swstrc(ji,jj)**3 )**pthird *   &
+               &                ( 1.0_wp - pdh(ji,jj) / phbl(ji,jj) ) * av_ds_ml(ji,jj)
+            IF ( dh(ji,jj) < 0.2_wp * hbl(ji,jj) ) THEN
+               zbuoy_pyc_sc        = 2.0_wp * MAX( av_db_ml(ji,jj), 0.0_wp ) / pdh(ji,jj)
+               zdelta_pyc          = ( svstr(ji,jj)**3 + swstrc(ji,jj)**3 )**pthird /   &
+                  &                       SQRT( MAX( zbuoy_pyc_sc, ( svstr(ji,jj)**3 + swstrc(ji,jj)**3 )**p2third / pdh(ji,jj)**2 ) )
+               zwt_pyc_sc_1(ji,jj) = 0.325_wp * ( zalpha_pyc(ji,jj) * av_dt_ml(ji,jj) / pdh(ji,jj) + pdtdz_bl_ext(ji,jj) ) *   &
+                  &                     zdelta_pyc**2 / pdh(ji,jj)
+               zws_pyc_sc_1(ji,jj) = 0.325_wp * ( zalpha_pyc(ji,jj) * av_ds_ml(ji,jj) / pdh(ji,jj) + pdsdz_bl_ext(ji,jj) ) *   &
+                  &                     zdelta_pyc**2 / pdh(ji,jj)
+               zzeta_pyc(ji,jj)    = 0.15_wp - 0.175_wp / ( 1.0_wp + EXP( -3.5_wp * LOG10( -1.0_wp * shol(ji,jj) ) ) )
+            END IF
+         END IF
+      END_2D
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, jkm_bld )
+         IF ( l_conv(ji,jj) .AND. l_pyc(ji,jj) .AND. ( jk <= nbld(ji,jj) ) ) THEN
+            zznd_pyc = -1.0_wp * ( gdepw(ji,jj,jk,Kmm) - phbl(ji,jj) ) / pdh(ji,jj)
+            ghamt(ji,jj,jk) = ghamt(ji,jj,jk) -                                                                                &
+               &              0.045_wp * ( ( zwth_ent(ji,jj) * zdbdz_pyc(ji,jj,jk) ) * ztau_sc_u(ji,jj)**2 ) *                 &
+               &                         MAX( ( 1.75_wp * zznd_pyc -0.15_wp * zznd_pyc**2 - 0.2_wp * zznd_pyc**3 ), 0.0_wp )
+            ghams(ji,jj,jk) = ghams(ji,jj,jk) -                                                                                &
+               &              0.045_wp * ( ( zws_ent(ji,jj)  * zdbdz_pyc(ji,jj,jk) ) * ztau_sc_u(ji,jj)**2 ) *                 &
+               &                         MAX( ( 1.75_wp * zznd_pyc -0.15_wp * zznd_pyc**2 - 0.2_wp * zznd_pyc**3 ), 0.0_wp )
+            IF ( dh(ji,jj) < 0.2_wp * hbl(ji,jj) .AND. nbld(ji,jj) - nmld(ji,jj) > 3 ) THEN
+               ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 0.05_wp  * zwt_pyc_sc_1(ji,jj) *                              &
+                  &                                EXP( -0.25_wp * ( zznd_pyc / zzeta_pyc(ji,jj) )**2 ) *        &
+                  &                                pdh(ji,jj) / ( svstr(ji,jj)**3 + swstrc(ji,jj)**3 )**pthird
+               ghams(ji,jj,jk) = ghams(ji,jj,jk) + 0.05_wp  * zws_pyc_sc_1(ji,jj) *                              &
+                  &                                EXP( -0.25_wp * ( zznd_pyc / zzeta_pyc(ji,jj) )**2 ) *        &
+                  &                                pdh(ji,jj) / ( svstr(ji,jj)**3 + swstrc(ji,jj)**3 )**pthird
+            END IF
+         END IF   ! End of pycnocline
+      END_3D
+      !
+      IF ( ln_dia_osm ) THEN
+         CALL zdf_osm_iomput( "zwth_ent", tmask(A2D(0),1) * zwth_ent(A2D(0)) )   ! Upward turb. temperature entrainment flux
+         CALL zdf_osm_iomput( "zws_ent",  tmask(A2D(0),1) * zws_ent(A2D(0))  )   ! Upward turb. salinity entrainment flux
+      END IF
+      !
+      zsc_vw_1(:,:) = 0.0_wp
+      WHERE ( l_conv(A2D(nn_hls-1)) )
+         zsc_uw_1(:,:) = -1.0_wp * swb0(A2D(nn_hls-1)) * sustar(A2D(nn_hls-1))**2 * phml(A2D(nn_hls-1)) /   &
+            &            ( svstr(A2D(nn_hls-1))**3 + 0.5_wp * swstrc(A2D(nn_hls-1))**3 + epsln )
+         zsc_uw_2(:,:) =           swb0(A2D(nn_hls-1)) * sustke(A2D(nn_hls-1))    * phml(A2D(nn_hls-1)) /   &
+            &            ( svstr(A2D(nn_hls-1))**3 + 0.5_wp * swstrc(A2D(nn_hls-1))**3 + epsln )**( 2.0_wp / 3.0_wp )
+      ELSEWHERE
+         zsc_uw_1(:,:) = 0.0_wp
+      ENDWHERE
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, MAX( jkm_mld, jkm_bld ) )
+         IF ( l_conv(ji,jj) ) THEN
+            IF ( jk <= nmld(ji,jj) ) THEN
+               zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + 0.3_wp * 0.5_wp *   &
+                  &                                ( zsc_uw_1(ji,jj) + 0.125_wp * EXP( -0.5_wp * zznd_d ) *       &
+                  &                                  (   1.0_wp - EXP( -0.5_wp * zznd_d ) ) * zsc_uw_2(ji,jj) )
+               ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zsc_vw_1(ji,jj)
+            END IF
+         ELSE   ! Stable conditions
+            IF ( jk <= nbld(ji,jj) ) THEN
+               ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + zsc_uw_1(ji,jj)
+               ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + zsc_vw_1(ji,jj)
+            END IF
          ENDIF
-
-      ELSE   ! lshear
-! for lshear = .FALSE. calculate ddhdt here
-
-          IF ( lconv(ji,jj) ) THEN
-
-            IF( ln_osm_mle ) THEN
-               IF ( ( zwb_ent(ji,jj) + 2.0 * zwb_fk_b(ji,jj) ) < 0._wp ) THEN
-                  ! OSBL is deepening. Note wb_fk_b is zero if ln_osm_mle=F
-                  IF ( zdb_bl(ji,jj) > 0._wp .and. zdbdz_bl_ext(ji,jj) > 0._wp)THEN
-                     IF ( ( zwstrc(ji,jj) / MAX(zvstr(ji,jj), epsln) )**3 <= 0.5 ) THEN  ! near neutral stability
-                        zari = MIN( 1.5 * zdb_bl(ji,jj) / ( zhbl(ji,jj) * ( MAX(zdbdz_bl_ext(ji,jj),0._wp) + zdb_bl(ji,jj)**2 / MAX(4.5 * zvstr(ji,jj)**2 , 1.e-12 )) ), 0.2d0 )
-                     ELSE                                                     ! unstable
-                        zari = MIN( 1.5 * zdb_bl(ji,jj) / ( zhbl(ji,jj) * ( MAX(zdbdz_bl_ext(ji,jj),0._wp) + zdb_bl(ji,jj)**2 / MAX(4.5 * zwstrc(ji,jj)**2 , 1.e-12 )) ), 0.2d0 )
-                     ENDIF
-                     ztau = 0.2 * hbl(ji,jj) / MAX(epsln, (zvstr(ji,jj)**3 + 0.5 *zwstrc(ji,jj)**3)**pthird)
-                     zdh_ref = zari * hbl(ji,jj)
+      END_3D
+      !
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         IF ( l_conv(ji,jj) .AND. l_pyc(ji,jj) ) THEN
+            IF ( n_ddh(ji,jj) == 0 ) THEN
+               ! Place holding code. Parametrization needs checking for these conditions.
+               zomega = ( 0.15_wp * swstrl(ji,jj)**3 + swstrc(ji,jj)**3 + 4.75_wp * ( pshear(ji,jj) * phbl(ji,jj) ) )**pthird
+               zuw_bse(ji,jj) = -0.0035_wp * zomega * ( 1.0_wp - pdh(ji,jj) / phbl(ji,jj) ) * av_du_ml(ji,jj)
+               zvw_bse(ji,jj) = -0.0075_wp * zomega * ( 1.0_wp - pdh(ji,jj) / phbl(ji,jj) ) * av_dv_ml(ji,jj)
+            ELSE
+               zomega = ( 0.15_wp * swstrl(ji,jj)**3 + swstrc(ji,jj)**3 + 4.75_wp * ( pshear(ji,jj) * phbl(ji,jj) ) )**pthird
+               zuw_bse(ji,jj) = -0.0035_wp * zomega * ( 1.0_wp - pdh(ji,jj) / phbl(ji,jj) ) * av_du_ml(ji,jj)
+               zvw_bse(ji,jj) = -0.0075_wp * zomega * ( 1.0_wp - pdh(ji,jj) / phbl(ji,jj) ) * av_dv_ml(ji,jj)
+            ENDIF
+            zb_cubic(ji,jj) = pdh(ji,jj) / phbl(ji,jj) * suw0(ji,jj) - ( 2.0_wp + pdh(ji,jj) / phml(ji,jj) ) * zuw_bse(ji,jj)
+            za_cubic(ji,jj) = zuw_bse(ji,jj) - zb_cubic(ji,jj)
+            zvw_max = 0.7_wp * ff_t(ji,jj) * ( sustke(ji,jj) * dstokes(ji,jj) + 0.7_wp * sustar(ji,jj) * phml(ji,jj) )
+            zd_cubic(ji,jj) = zvw_max * pdh(ji,jj) / phml(ji,jj) - ( 2.0_wp + pdh(ji,jj) / phml(ji,jj) ) * zvw_bse(ji,jj)
+            zc_cubic(ji,jj) = zvw_bse(ji,jj) - zd_cubic(ji,jj)
+         END IF
+      END_2D
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, jkf_mld, jkm_bld )   ! Need ztau_sc_u to be available. Change to array.
+         IF ( l_conv(ji,jj) .AND. l_pyc(ji,jj) .AND. ( jk >= nmld(ji,jj) ) .AND. ( jk <= nbld(ji,jj) ) ) THEN
+            zznd_pyc = -1.0_wp * ( gdepw(ji,jj,jk,Kmm) - phbl(ji,jj) ) / pdh(ji,jj)
+            ghamu(ji,jj,jk) = ghamu(ji,jj,jk) - 0.045_wp * ( ztau_sc_u(ji,jj)**2 ) * zuw_bse(ji,jj) *                 &
+               &                                ( za_cubic(ji,jj) * zznd_pyc**2 + zb_cubic(ji,jj) * zznd_pyc**3 ) *   &
+               &                                ( 0.75_wp + 0.25_wp * zznd_pyc )**2 * zdbdz_pyc(ji,jj,jk)
+            ghamv(ji,jj,jk) = ghamv(ji,jj,jk) - 0.045_wp * ( ztau_sc_u(ji,jj)**2 ) * zvw_bse(ji,jj) *                 &
+               &                                ( zc_cubic(ji,jj) * zznd_pyc**2 + zd_cubic(ji,jj) * zznd_pyc**3 ) *   &
+               &                                ( 0.75_wp + 0.25_wp * zznd_pyc )**2 * zdbdz_pyc(ji,jj,jk)
+         END IF   ! l_conv .AND. l_pyc
+      END_3D
+      !
+      IF ( ln_dia_osm ) THEN
+         CALL zdf_osm_iomput( "ghamu_0",    wmask(A2D(0),:) * ghamu(A2D(0),:)  )
+         CALL zdf_osm_iomput( "zsc_uw_1_0", tmask(A2D(0),1) * zsc_uw_1(A2D(0)) )
+      END IF
+      !
+      ! Transport term in flux-gradient relationship [note : includes ROI ratio
+      ! (X0.3) ]
+      ! -----------------------------------------------------------------------
+      WHERE ( l_conv(A2D(nn_hls-1)) )
+         zsc_wth_1(:,:) = swth0(A2D(nn_hls-1)) / ( 1.0_wp - 0.56_wp * EXP( shol(A2D(nn_hls-1)) ) )
+         zsc_ws_1(:,:)  = sws0(A2D(nn_hls-1))  / ( 1.0_wp - 0.56_wp * EXP( shol(A2D(nn_hls-1)) ) )
+         WHERE ( l_pyc(A2D(nn_hls-1)) )   ! Pycnocline scales
+            zsc_wth_pyc(:,:) = -0.003_wp * swstrc(A2D(nn_hls-1)) * ( 1.0_wp - pdh(A2D(nn_hls-1)) / phbl(A2D(nn_hls-1)) ) *   &
+               &               av_dt_ml(A2D(nn_hls-1))
+            zsc_ws_pyc(:,:)  = -0.003_wp * swstrc(A2D(nn_hls-1)) * ( 1.0_wp - pdh(A2D(nn_hls-1)) / phbl(A2D(nn_hls-1)) ) *   &
+               &               av_ds_ml(A2D(nn_hls-1))
+         END WHERE
+      ELSEWHERE
+         zsc_wth_1(:,:) = 2.0_wp * swthav(A2D(nn_hls-1))
+         zsc_ws_1(:,:)  =          sws0(A2D(nn_hls-1))
+      END WHERE
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 1, MAX( jkm_mld, jkm_bld ) )
+         IF ( l_conv(ji,jj) ) THEN
+            IF ( ( jk > 1 ) .AND. ( jk <= nmld(ji,jj) ) ) THEN
+               zznd_ml = gdepw(ji,jj,jk,Kmm) / phml(ji,jj)
+               ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 0.3_wp * zsc_wth_1(ji,jj) *                                  &
+                  &                                ( -2.0_wp + 2.75_wp * ( ( 1.0_wp + 0.6_wp * zznd_ml**4 ) -   &
+                  &                                                        EXP( -6.0_wp * zznd_ml ) ) ) *       &
+                  &                                ( 1.0_wp - EXP( -15.0_wp * ( 1.0_wp - zznd_ml ) ) )
+               ghams(ji,jj,jk) = ghams(ji,jj,jk) + 0.3_wp * zsc_ws_1(ji,jj) *                                   &
+                  &                                ( -2.0_wp + 2.75_wp * ( ( 1.0_wp + 0.6_wp * zznd_ml**4 ) -   &
+                  &                                EXP( -6.0_wp * zznd_ml ) ) ) * ( 1.0_wp - EXP( -15.0_wp * ( 1.0_wp - zznd_ml ) ) )
+            END IF
+            !
+            ! may need to comment out lpyc block
+            IF ( l_pyc(ji,jj) .AND. ( jk >= nmld(ji,jj) ) .AND. ( jk <= nbld(ji,jj) ) ) THEN   ! Pycnocline
+               zznd_pyc = -1.0_wp * ( gdepw(ji,jj,jk,Kmm) - phbl(ji,jj) ) / pdh(ji,jj)
+               ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 4.0_wp * zsc_wth_pyc(ji,jj) *   &
+                  &                                ( 0.48_wp - EXP( -1.5_wp * ( zznd_pyc - 0.3_wp )**2 ) )
+               ghams(ji,jj,jk) = ghams(ji,jj,jk) + 4.0_wp * zsc_ws_pyc(ji,jj)  *   &
+                  &                                ( 0.48_wp - EXP( -1.5_wp * ( zznd_pyc - 0.3_wp )**2 ) )
+            END IF
+         ELSE
+            IF( pdhdt(ji,jj) > 0. ) THEN
+               IF ( ( jk > 1 ) .AND. ( jk <= nbld(ji,jj) ) ) THEN
+                  zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+                  znd    = gdepw(ji,jj,jk,Kmm) / phbl(ji,jj)
+                  ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + 0.3_wp * ( -4.06_wp * EXP( -2.0_wp * zznd_d ) * ( 1.0_wp - EXP( -4.0_wp * zznd_d ) ) +   &
+                     7.5_wp * EXP ( -10.0_wp * ( 0.95_wp - znd )**2 ) * ( 1.0_wp - znd ) ) * zsc_wth_1(ji,jj)
+                  ghams(ji,jj,jk) = ghams(ji,jj,jk) + 0.3_wp * ( -4.06_wp * EXP( -2.0_wp * zznd_d ) * ( 1.0_wp - EXP( -4.0_wp * zznd_d ) ) +   &
+                     7.5_wp * EXP ( -10.0_wp * ( 0.95_wp - znd )**2 ) * ( 1.0_wp - znd ) ) * zsc_ws_1(ji,jj)
+               END IF
+            ENDIF
+         ENDIF
+      END_3D
+      !
+      WHERE ( l_conv(A2D(nn_hls-1)) )
+         zsc_uw_1(:,:) = sustar(A2D(nn_hls-1))**2
+         zsc_vw_1(:,:) = ff_t(A2D(nn_hls-1)) * sustke(A2D(nn_hls-1)) * phml(A2D(nn_hls-1))
+      ELSEWHERE
+         zsc_uw_1(:,:) = sustar(A2D(nn_hls-1))**2
+         zsc_uw_2(:,:) = ( 2.25_wp - 3.0_wp * ( 1.0_wp - EXP( -1.25_wp * 2.0_wp ) ) ) * ( 1.0_wp - EXP( -4.0_wp * 2.0_wp ) ) *   &
+            &            zsc_uw_1(:,:)
+         zsc_vw_1(:,:) = ff_t(A2D(nn_hls-1)) * sustke(A2D(nn_hls-1)) * phbl(A2D(nn_hls-1))
+         zsc_vw_2(:,:) = -0.11_wp * SIN( 3.14159_wp * ( 2.0_wp + 0.4_wp ) ) * EXP( -1.0_wp * ( 1.5_wp + 2.0_wp )**2 ) *   &
+            &            zsc_vw_1(:,:)
+      ENDWHERE
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, MAX( jkm_mld, jkm_bld ) )
+         IF ( l_conv(ji,jj) ) THEN
+            IF ( jk <= nmld(ji,jj) ) THEN
+               zznd_ml = gdepw(ji,jj,jk,Kmm) / phml(ji,jj)
+               zznd_d  = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               ghamu(ji,jj,jk) = ghamu(ji,jj,jk) +   &
+                  &              0.3_wp * ( -2.0_wp + 2.5_wp * ( 1.0_wp + 0.1_wp * zznd_ml**4 ) - EXP( -8.0_wp * zznd_ml ) ) *   &
+                  &              zsc_uw_1(ji,jj)
+               ghamv(ji,jj,jk) = ghamv(ji,jj,jk) +   &
+                  &              0.3_wp * 0.1_wp * ( EXP( -1.0_wp * zznd_d ) + EXP( -5.0_wp * ( 1.0_wp - zznd_ml ) ) ) *   &
+                  &              zsc_vw_1(ji,jj)
+            END IF
+         ELSE
+            IF ( jk <= nbld(ji,jj) ) THEN
+               znd    = gdepw(ji,jj,jk,Kmm) / phbl(ji,jj)
+               zznd_d = gdepw(ji,jj,jk,Kmm) / dstokes(ji,jj)
+               IF ( zznd_d <= 2.0_wp ) THEN
+                  ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + 0.5_wp * 0.3_wp *                                              &
+                     &                                ( 2.25_wp - 3.0_wp * ( 1.0_wp - EXP( -1.25_wp * zznd_d ) ) *   &
+                     &                                  ( 1.0_wp - EXP( -2.0_wp * zznd_d ) ) ) * zsc_uw_1(ji,jj)
+               ELSE
+                  ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + 0.5_wp * 0.3_wp *   &
+                     &                                ( 1.0_wp - EXP( -5.0_wp * ( 1.0_wp - znd ) ) ) * zsc_uw_2(ji,jj)
+               ENDIF
+               ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + 0.3_wp * 0.15_wp * SIN( 3.14159_wp * ( 0.65_wp * zznd_d ) ) *   &
+                  &                                EXP( -0.25_wp * zznd_d**2 ) * zsc_vw_1(ji,jj)
+               ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + 0.3_wp * 0.15_wp * EXP( -5.0 * ( 1.0 - znd ) ) *   &
+                  &                                ( 1.0 - EXP( -20.0 * ( 1.0 - znd ) ) ) * zsc_vw_2(ji,jj)
+            END IF
+         END IF
+      END_3D
+      !
+      IF ( ln_dia_osm ) THEN
+         CALL zdf_osm_iomput( "ghamu_f",    wmask(A2D(0),:) * ghamu(A2D(0),:)  )
+         CALL zdf_osm_iomput( "ghamv_f",    wmask(A2D(0),:) * ghamv(A2D(0),:)  )
+         CALL zdf_osm_iomput( "zsc_uw_1_f", tmask(A2D(0),1) * zsc_uw_1(A2D(0)) )
+         CALL zdf_osm_iomput( "zsc_vw_1_f", tmask(A2D(0),1) * zsc_vw_1(A2D(0)) )
+         CALL zdf_osm_iomput( "zsc_uw_2_f", tmask(A2D(0),1) * zsc_uw_2(A2D(0)) )
+         CALL zdf_osm_iomput( "zsc_vw_2_f", tmask(A2D(0),1) * zsc_vw_2(A2D(0)) )
+      END IF
+      !
+      ! Make surface forced velocity non-gradient terms go to zero at the base
+      ! of the mixed layer.
+      !
+      ! Make surface forced velocity non-gradient terms go to zero at the base
+      ! of the boundary layer.
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, jkm_bld )
+         IF ( ( .NOT. l_conv(ji,jj) ) .AND. ( jk <= nbld(ji,jj) ) ) THEN
+            znd = -1.0_wp * ( gdepw(ji,jj,jk,Kmm) - phbl(ji,jj) ) / phbl(ji,jj)   ! ALMG to think about
+            IF ( znd >= 0.0_wp ) THEN
+               ghamu(ji,jj,jk) = ghamu(ji,jj,jk) * ( 1.0_wp - EXP( -10.0_wp * znd**2 ) )
+               ghamv(ji,jj,jk) = ghamv(ji,jj,jk) * ( 1.0_wp - EXP( -10.0_wp * znd**2 ) )
+            ELSE
+               ghamu(ji,jj,jk) = 0.0_wp
+               ghamv(ji,jj,jk) = 0.0_wp
+            ENDIF
+         END IF
+      END_3D
+      !
+      ! Pynocline contributions
+      !
+      IF ( ln_dia_pyc_scl .OR. ln_dia_pyc_shr ) THEN   ! Allocate arrays for output of pycnocline gradient/shear profiles
+         ALLOCATE( z3ddz_pyc_1(A2D(nn_hls),jpk), z3ddz_pyc_2(A2D(nn_hls),jpk), STAT=istat )
+         IF ( istat /= 0 ) CALL ctl_stop( 'zdf_osm: failed to allocate temporary arrays' )
+         z3ddz_pyc_1(:,:,:) = 0.0_wp
+         z3ddz_pyc_2(:,:,:) = 0.0_wp
+      END IF
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, jkm_bld )
+         IF ( l_conv (ji,jj) ) THEN
+            ! Unstable conditions. Shouldn;t be needed with no pycnocline code.
+            !                  zugrad = 0.7 * av_du_ml(ji,jj) / zdh(ji,jj) + 0.3 * zustar(ji,jj)*zustar(ji,jj) / &
+            !                       &      ( ( ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird * zhml(ji,jj) ) * &
+            !                      &      MIN(zla(ji,jj)**(8.0/3.0) + epsln, 0.12 ))
+            !Alan is this right?
+            !                  zvgrad = ( 0.7 * av_dv_ml(ji,jj) + &
+            !                       &    2.0 * ff_t(ji,jj) * zustke(ji,jj) * dstokes(ji,jj) / &
+            !                       &          ( ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird  + epsln ) &
+            !                       &      )/ (zdh(ji,jj)  + epsln )
+            !                  DO jk = 2, nbld(ji,jj) - 1 + ibld_ext
+            !                     znd = -( gdepw(ji,jj,jk,Kmm) - zhbl(ji,jj) ) / (zdh(ji,jj) + epsln ) - zzeta_v
+            !                     IF ( znd <= 0.0 ) THEN
+            !                        zdudz(ji,jj,jk) = 1.25 * zugrad * EXP( 3.0 * znd )
+            !                        zdvdz(ji,jj,jk) = 1.25 * zvgrad * EXP( 3.0 * znd )
+            !                     ELSE
+            !                        zdudz(ji,jj,jk) = 1.25 * zugrad * EXP( -2.0 * znd )
+            !                        zdvdz(ji,jj,jk) = 1.25 * zvgrad * EXP( -2.0 * znd )
+            !                     ENDIF
+            !                  END DO
+         ELSE   ! Stable conditions
+            IF ( nbld(ji,jj) + kp_ext(ji,jj) < mbkt(ji,jj) ) THEN
+               ! Pycnocline profile only defined when depth steady of increasing.
+               IF ( pdhdt(ji,jj) > 0.0_wp ) THEN   ! Depth increasing, or steady.
+                  IF ( av_db_bl(ji,jj) > 0.0_wp ) THEN
+                     IF ( shol(ji,jj) >= 0.5_wp ) THEN   ! Very stable - 'thick' pycnocline
+                        ztmp = 1.0_wp / MAX( phbl(ji,jj), epsln )
+                        ztgrad = av_dt_bl(ji,jj) * ztmp
+                        zsgrad = av_ds_bl(ji,jj) * ztmp
+                        zbgrad = av_db_bl(ji,jj) * ztmp
+                        IF ( jk <= nbld(ji,jj) ) THEN
+                           znd = gdepw(ji,jj,jk,Kmm) * ztmp
+                           zdtdz_pyc =  ztgrad * EXP( -15.0_wp * ( znd - 0.9_wp )**2 )
+                           zdsdz_pyc =  zsgrad * EXP( -15.0_wp * ( znd - 0.9_wp )**2 )
+                           ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + pdiffut(ji,jj,jk) * zdtdz_pyc
+                           ghams(ji,jj,jk) = ghams(ji,jj,jk) + pdiffut(ji,jj,jk) * zdsdz_pyc
+                           IF ( ln_dia_pyc_scl ) THEN
+                              z3ddz_pyc_1(ji,jj,jk) = zdtdz_pyc
+                              z3ddz_pyc_2(ji,jj,jk) = zdsdz_pyc
+                           END IF
+                        END IF
+                     ELSE   ! Slightly stable - 'thin' pycnoline - needed when stable layer begins to form.
+                        ztmp = 1.0_wp / MAX( pdh(ji,jj), epsln )
+                        ztgrad = av_dt_bl(ji,jj) * ztmp
+                        zsgrad = av_ds_bl(ji,jj) * ztmp
+                        zbgrad = av_db_bl(ji,jj) * ztmp
+                        IF ( jk <= nbld(ji,jj) ) THEN
+                           znd = -1.0_wp * ( gdepw(ji,jj,jk,Kmm) - phml(ji,jj) ) * ztmp
+                           zdtdz_pyc =  ztgrad * EXP( -1.75_wp * ( znd + 0.75_wp )**2 )
+                           zdsdz_pyc =  zsgrad * EXP( -1.75_wp * ( znd + 0.75_wp )**2 )
+                           ghamt(ji,jj,jk) = ghamt(ji,jj,jk) + pdiffut(ji,jj,jk) * zdtdz_pyc
+                           ghams(ji,jj,jk) = ghams(ji,jj,jk) + pdiffut(ji,jj,jk) * zdsdz_pyc
+                           IF ( ln_dia_pyc_scl ) THEN
+                              z3ddz_pyc_1(ji,jj,jk) = zdtdz_pyc
+                              z3ddz_pyc_2(ji,jj,jk) = zdsdz_pyc
+                           END IF
+                        END IF
+                     ENDIF   ! IF (shol >=0.5)
+                  ENDIF      ! IF (av_db_bl> 0.)
+               ENDIF         ! IF (zdhdt >= 0) zdhdt < 0 not considered since pycnocline profile is zero and profile arrays are
+               !             !    intialized to zero
+            END IF
+         END IF
+      END_3D
+      IF ( ln_dia_pyc_scl ) THEN   ! Output of pycnocline gradient profiles
+         CALL zdf_osm_iomput( "zdtdz_pyc", wmask(A2D(0),:) * z3ddz_pyc_1(A2D(0),:) )
+         CALL zdf_osm_iomput( "zdsdz_pyc", wmask(A2D(0),:) * z3ddz_pyc_2(A2D(0),:) )
+      END IF
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, jkm_bld )
+         IF ( .NOT. l_conv (ji,jj) ) THEN
+            IF ( nbld(ji,jj) + kp_ext(ji,jj) < mbkt(ji,jj) ) THEN
+               zugrad = 3.25_wp * av_du_bl(ji,jj) / phbl(ji,jj)
+               zvgrad = 2.75_wp * av_dv_bl(ji,jj) / phbl(ji,jj)
+               IF ( jk <= nbld(ji,jj) ) THEN
+                  znd = gdepw(ji,jj,jk,Kmm) / phbl(ji,jj)
+                  IF ( znd < 1.0 ) THEN
+                     zdudz_pyc = zugrad * EXP( -40.0_wp * ( znd - 1.0_wp )**2 )
                   ELSE
-                     ztau = 0.2 * hbl(ji,jj) / MAX(epsln, (zvstr(ji,jj)**3 + 0.5 *zwstrc(ji,jj)**3)**pthird)
-                     zdh_ref = 0.2 * hbl(ji,jj)
+                     zdudz_pyc = zugrad * EXP( -20.0_wp * ( znd - 1.0_wp )**2 )
                   ENDIF
-               ELSE
-                  ztau = 0.2 * hbl(ji,jj) /  MAX(epsln, (zvstr(ji,jj)**3 + 0.5 *zwstrc(ji,jj)**3)**pthird)
-                  zdh_ref = 0.2 * hbl(ji,jj)
-               ENDIF
-            ELSE ! ln_osm_mle
-               IF ( zdb_bl(ji,jj) > 0._wp .and. zdbdz_bl_ext(ji,jj) > 0._wp)THEN
-                  IF ( ( zwstrc(ji,jj) / MAX(zvstr(ji,jj), epsln) )**3 <= 0.5 ) THEN  ! near neutral stability
-                     zari = MIN( 1.5 * zdb_bl(ji,jj) / ( zhbl(ji,jj) * ( MAX(zdbdz_bl_ext(ji,jj),0._wp) + zdb_bl(ji,jj)**2 / MAX(4.5 * zvstr(ji,jj)**2 , 1.e-12 )) ), 0.2d0 )
-                  ELSE                                                     ! unstable
-                     zari = MIN( 1.5 * zdb_bl(ji,jj) / ( zhbl(ji,jj) * ( MAX(zdbdz_bl_ext(ji,jj),0._wp) + zdb_bl(ji,jj)**2 / MAX(4.5 * zwstrc(ji,jj)**2 , 1.e-12 )) ), 0.2d0 )
-                  ENDIF
-                  ztau = hbl(ji,jj) / MAX(epsln, (zvstr(ji,jj)**3 + 0.5 *zwstrc(ji,jj)**3)**pthird)
-                  zdh_ref = zari * hbl(ji,jj)
-               ELSE
-                  ztau = hbl(ji,jj) / MAX(epsln, (zvstr(ji,jj)**3 + 0.5 *zwstrc(ji,jj)**3)**pthird)
-                  zdh_ref = 0.2 * hbl(ji,jj)
-               ENDIF
-
-            END IF  ! ln_osm_mle
-
-            dh(ji,jj) = dh(ji,jj) * EXP( -rn_Dt / ztau ) + zdh_ref * ( 1.0 - EXP( -rn_Dt / ztau ) )
-!               IF ( zdhdt(ji,jj) < 0._wp .and. dh(ji,jj) >= hbl(ji,jj) ) dh(ji,jj) = zdh_ref
-            IF ( dh(ji,jj) >= hbl(ji,jj) ) dh(ji,jj) = zdh_ref
-            ! Alan: this hml is never defined or used
-         ELSE   ! IF (lconv)
-            ztau = hbl(ji,jj) / MAX(zvstr(ji,jj), epsln)
-            IF ( zdhdt(ji,jj) >= 0.0 ) THEN    ! probably shouldn't include wm here
-               ! boundary layer deepening
-               IF ( zdb_bl(ji,jj) > 0._wp ) THEN
-                  ! pycnocline thickness set by stratification - use same relationship as for neutral conditions.
-                  zari = MIN( 4.5 * ( zvstr(ji,jj)**2 ) &
-                       & /  MAX(zdb_bl(ji,jj) * zhbl(ji,jj), epsln ) + 0.01  , 0.2 )
-                  zdh_ref = MIN( zari, 0.2 ) * hbl(ji,jj)
-               ELSE
-                  zdh_ref = 0.2 * hbl(ji,jj)
-               ENDIF
-            ELSE     ! IF(dhdt < 0)
-               zdh_ref = 0.2 * hbl(ji,jj)
-            ENDIF    ! IF (dhdt >= 0)
-            dh(ji,jj) = dh(ji,jj) * EXP( -rn_Dt / ztau )+ zdh_ref * ( 1.0 - EXP( -rn_Dt / ztau ) )
-            IF ( zdhdt(ji,jj) < 0._wp .and. dh(ji,jj) >= hbl(ji,jj) ) dh(ji,jj) = zdh_ref       ! can be a problem with dh>hbl for rapid collapse
-         ENDIF       ! IF (lconv)
-      ENDIF  ! lshear
-
-      hml(ji,jj) = hbl(ji,jj) - dh(ji,jj)
-      inhml = MAX( INT( dh(ji,jj) / MAX(e3t(ji,jj,ibld(ji,jj),Kmm), 1.e-3) ) , 1 )
-      imld(ji,jj) = MAX( ibld(ji,jj) - inhml, 3)
-      zhml(ji,jj) = gdepw(ji,jj,imld(ji,jj),Kmm)
-      zdh(ji,jj) = zhbl(ji,jj) - zhml(ji,jj)
-    END_2D
-
-    END SUBROUTINE zdf_osm_pycnocline_thickness
-
-
-   SUBROUTINE zdf_osm_zmld_horizontal_gradients( zmld, zdtdx, zdtdy, zdsdx, zdsdy, dbdx_mle, dbdy_mle, zdbds_mle )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE zdf_osm_horizontal_gradients  ***
-      !!
-      !! ** Purpose :   Calculates horizontal gradients of buoyancy for use with Fox-Kemper parametrization.
+                  zdvdz_pyc = zvgrad * EXP( -20.0_wp * ( znd - 0.85_wp )**2 )
+                  ghamu(ji,jj,jk) = ghamu(ji,jj,jk) + pviscos(ji,jj,jk) * zdudz_pyc
+                  ghamv(ji,jj,jk) = ghamv(ji,jj,jk) + pviscos(ji,jj,jk) * zdvdz_pyc
+                  IF ( ln_dia_pyc_shr ) THEN
+                     z3ddz_pyc_1(ji,jj,jk) = zdudz_pyc
+                     z3ddz_pyc_2(ji,jj,jk) = zdvdz_pyc
+                  END IF
+               END IF
+            END IF
+         END IF
+      END_3D
+      IF ( ln_dia_pyc_shr ) THEN   ! Output of pycnocline shear profiles
+         CALL zdf_osm_iomput( "zdudz_pyc", wmask(A2D(0),:) * z3ddz_pyc_1(A2D(0),:) )
+         CALL zdf_osm_iomput( "zdvdz_pyc", wmask(A2D(0),:) * z3ddz_pyc_2(A2D(0),:) )
+      END IF
+      IF ( ln_dia_osm ) THEN
+         CALL zdf_osm_iomput( "ghamu_b", wmask(A2D(0),:) * ghamu(A2D(0),:) )
+         CALL zdf_osm_iomput( "ghamv_b", wmask(A2D(0),:) * ghamv(A2D(0),:) )
+      END IF
+      IF ( ln_dia_pyc_scl .OR. ln_dia_pyc_shr ) THEN   ! Deallocate arrays used for output of pycnocline gradient/shear profiles
+         DEALLOCATE( z3ddz_pyc_1, z3ddz_pyc_2 )
+      END IF
+      !
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         ghamt(ji,jj,nbld(ji,jj)) = 0.0_wp
+         ghams(ji,jj,nbld(ji,jj)) = 0.0_wp
+         ghamu(ji,jj,nbld(ji,jj)) = 0.0_wp
+         ghamv(ji,jj,nbld(ji,jj)) = 0.0_wp
+      END_2D
+      !
+      IF ( ln_dia_osm ) THEN
+         CALL zdf_osm_iomput( "ghamu_1", wmask(A2D(0),:) * ghamu(A2D(0),:)   )
+         CALL zdf_osm_iomput( "ghamv_1", wmask(A2D(0),:) * ghamv(A2D(0),:)   )
+         CALL zdf_osm_iomput( "zviscos", wmask(A2D(0),:) * pviscos(A2D(0),:) )
+      END IF
+      !
+   END SUBROUTINE zdf_osm_fgr_terms
+
+   SUBROUTINE zdf_osm_zmld_horizontal_gradients( Kmm, pmld, pdtdx, pdtdy, pdsdx,   &
+      &                                          pdsdy, pdbds_mle )
+      !!----------------------------------------------------------------------
+      !!          ***  ROUTINE zdf_osm_zmld_horizontal_gradients  ***
+      !!
+      !! ** Purpose : Calculates horizontal gradients of buoyancy for use with
+      !!              Fox-Kemper parametrization
       !!
       !! ** Method  :
